#include <bits/stdc++.h>

using namespace std;

vector<string> getTokens(string& s, char delim) {
    if (s.empty()) return {};

    vector<string> tokens(1);
    for (char c: s) {
        if (c == delim) tokens.push_back("");
        else tokens.back().push_back(c);
    }
    return tokens;
}

bool isInt(string& s) {
    if (s.size() == 0) return false;
    if (s.size() >= 10) return false;
    for (char c: s) {
        if (!isdigit(c)) return false;
    }
    return true;
}

int toInt(string& s) {
    int ans = 0;
    for (char c: s) {
        ans = 10*ans+c-'0';
    }
    return ans;
}

void finish(bool ok1, bool ok2, string message) {
    if (ok1 && ok2) cout << 1 << endl;
    else if (ok1) cout << 0.5 << endl;
    else cout << 0 << endl;

    if (message.size()) cerr << message << endl;
    exit(0);
}

int main(int argc, char *argv[]) {
    ifstream in(argv[1]);
    ifstream sol(argv[2]);
    ifstream out(argv[3]);

    if (!in) {
        finish(0, 0, "In-файл "+string(argv[1])+" не е намерен.");
    }
    if (!sol) {
        finish(0, 0, "Sol-файл "+string(argv[2])+" не е намерен.");
    }
    if (!out) {
        finish(0, 0, "Out-файл "+string(argv[3])+" не е намерен.");
    }

    string message;
    int solAns, outAns;
    sol >> solAns;
    if (!(out >> outAns)) {
        message += "Липсва броя операции\n";
        finish(0, 0, message);
    }

    if (solAns != outAns) {
        message += "Грешен брой операции\n";
        finish(0, 0, message);
    }

    message += "Верен брой операции\n";

    string s;
    if (!getline(out, s) || !getline(out, s)) {
        message += "Липсва последователност от операции";
        finish(1, 0, message);
    }

    while (s.size() && s[0] == ' ') s.erase(0, 1);
    while (s.size() && s.back() == ' ') s.pop_back();

    bool badSymbols = false;
    for (char c: s) {
        if (c != ' ' && !isdigit(c)) {
            badSymbols = true;
        }
    }

    if (badSymbols) {
        message += "На втория ред има символ различен от интервал и цифра";
        finish(1, 0, message);
    }

    vector<string> tokens = getTokens(s, ' ');
    if (tokens.size() != solAns) {
        message += "Броят операции в дадената от вас последователност е грешен";
        finish(1, 0, message);
    }

    for (string& token: tokens) {
        if (!isInt(token)) {
            message += "Има невалиден номер на операция";
            finish(1, 0, message);
        }
    }

    vector<int> operations;
    for (string& token: tokens) {
        int operation = toInt(token);
        if (operation != 1 && operation != 2) {
            message += "Има невалиден номер на операция";
            finish(1, 0, message);
        }
        operations.push_back(operation);
    }

    for (int i = 0; i < solAns; i++) {
        int op; sol >> op;
        if (op != operations[i]) {
            message += "Грешна последователност от операции";
            finish(1, 0, message);
        }
    }

    message += "Вярна последователност от операции";
    finish(1, 1, message);

    return 0;
}
